/***************************************************************************\
	EtherNet Modem Example - Slave
		Copyright (c) 1999, Me.
		9/28/99
\***************************************************************************/

#use		"VDRIVER.LIB"						//	Costates & Timers
#use		"AASCZ0.LIB"						//	Serial Port Z0

struct _Channel	*pZ0;						//	Z0 Handle

void
main				(	void
					)

{	static char		acR0[128];				//	Z0 Serial Buffers
	static char		acT0[128];
	char				*pcMsg,acMsg[64];		//	Message Buffering
		
		VdInit ();								//	Init Costates & Timers
		lcd_init ( 0x18 );					//	Init LCD
		lputc ( 0xF2 );						//	Cursor Off

		//	Init Z0 (RJ12) for 9600 N81
		
		pZ0 = aascOpen ( DEV_Z0,0,ASCI_PARAM_8N1+ASCI_PARAM_1200*16,NULL );
		aascSetReadBuf ( pZ0,acR0,sizeof(acR0) );
		aascSetWriteBuf ( pZ0,acT0,sizeof(acT0) );
		aascTxSwitch ( pZ0,1 );
		aascRxSwitch ( pZ0,1 );

		for (;;) {								//	Forever
			costate {									//	Read & Echo CR Terminated Messages
				pcMsg = acMsg;								//	Init Buffer Pointer
				do {											//	Wait for Next Serial Byte
					waitfor ( aascReadChar(pZ0,pcMsg) );
				} while (*pcMsg++ != '\0');			//	Continue til Terminator Read
				lprintf ( "\xF0In  : %s",acMsg );	//	Display Recevied Message
																//	Echo Reply
				waitfor ( aascWriteBlk(pZ0,acMsg,pcMsg-acMsg,1) );
				lprintf ( "\xF1Out : %s",acMsg );	//	Display Echoed Message
			}
			//	Other Costatements Here!!!
		}
}
